#include "s2p.h"

using namespace std;
using namespace io;

void s2p_encode::init(){
    s2p.set_sink(&buffer);
}

void s2p_encode::tick(){
    s2p.send(param_id, in_blob.data, in_blob.size);
    out_stream.realloc(buffer.data, buffer.bytes_used);
    buffer.flush();
}

void s2p_decode::init(){
    s2p.set_source(&buffer);
    s2p.on_new_pack = [this](size_t id, void* data, size_t size){
        if(id == param_id){
            out_blob.realloc(data, size);
        }
	};
}


void s2p_decode::tick(){
    if(in_stream.size > 0){
        buffer.send(in_stream.data, in_stream.size);
    }
}
