#include "udp.h"

using namespace std;
using namespace io;

void udp_snd::init(){
    con.reset(new abmt::io::udp(lst,{param_target, param_port}));
    lst.wait(0);
}

void udp_snd::tick(){
    lst.wait(0); // calls on_new_data and other events
    if(in.size > 0){
        con->send(in.data, in.size);
    }
}


void udp_rcv::init(){
    con.reset(new abmt::io::udp(lst,{}, {param_target, param_port}));
    con->on_new_data = [this](abmt::blob& b)->size_t{
		out += b;
	    return b.size;
	};
	lst.wait(0);
}

abmt::time udp_rcv::poll(){
    out.realloc(0);
    lst.wait(1000); // calls on_new_data and other events
    if(out.size != 0){
        return 0;
    }
    return 1;
}
