#ifndef IO_UDP_H
#define IO_UDP_H IO_UDP_H

#include <string>
#include <cstdint>
#include <abmt/blob.h>
#include <abmt/io/eio.h>
#include <abmt/time.h>

namespace io{
    
//@node: auto
struct udp_snd{
    abmt::blob_shared in;
    std::string param_target = "localhost";
    uint16_t param_port = 12345;
    
    abmt::io::event_list lst;
    abmt::io::udp_ptr con;
    
    void init();
    void tick();
};

//@node: auto
//@raster: source
struct udp_rcv{
    abmt::blob_shared out;
    std::string param_target = "any";
    uint16_t param_port = 12345;
    
    abmt::io::event_list lst;
    abmt::io::udp_ptr con;
    
    void init();
    abmt::time poll();
};



} // namespace io

#endif // IO_UDP_H
