#include "file.h"

#include <sys/stat.h>
#include <sys/mman.h> 
#include <fcntl.h>
#include <unistd.h>

using namespace std;
using namespace utils;
namespace fs = std::filesystem;


void read_file::tick(){
    if(param_check_for_updates || first_start){
        first_start = false;
        if(fs::exists(param_file)){
            if(last_read_time != std::filesystem::last_write_time(param_file)){
                last_read_time = std::filesystem::last_write_time(param_file);
                int fd = open(param_file.c_str(), O_RDONLY);
                abmt::die_if(fd < 0, "error open file " + param_file);
                struct stat s = {};
                fstat (fd, &s);
                auto data = (char*) mmap(0, s.st_size, PROT_READ, MAP_PRIVATE, fd, 0);
                abmt::die_if(data == MAP_FAILED || s.st_size == 0, "error map file " + param_file);
                out_blob.realloc(data, s.st_size);
                munmap(data, s.st_size);
                close(fd);
            }
        }else{
            out_blob = param_default_content;
        }
    } // chk_updates || first start
}

void write_file::tick(){
    auto file = fopen(param_file.c_str(), "wb");
    abmt::die_if(file == 0, "record: unable to open " + param_file);
    fwrite(in_blob.data,in_blob.size,1,(FILE*)file);
    fclose((FILE*)file);
}
